unit Unit1;

{
Programmfunktion:
           HAL
Hersteller:
           LinSoft Jürgen linder (juelin) dg5uap@darc.de
Lizens:
           privat
Hardware:
           keine zusätzliche Hardware
Software:
           Folgende Files
           hal.exe, hal.ico, hal.lpi, hal.lpr, hal.lps, hal.res, hal.bmp, unit1.lfm, unit1.pas müssen im Soucepfad vorhanden sein

wie Compelieren:
           Lazarus IDE mit FPC
wie Ausführen:
           Ausführen hal.exe (Icon)
}

// Tastenkombination
//        WIN+H            Spracheinagbe für Programm starten
//        WIN+STRG+S       Sprachausgabe für Desktop starten und Einstellungen

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs,
  StdCtrls, pl_Win_API,
  ExtCtrls, Variants, ComObj, Windows, LCLType,
  Lazutf8, DateUtils;

type

  { TForm1 }

  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    Edit1: TEdit;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    Timer1: TTimer;
    Timer2: TTimer;
    procedure CheckBox1Change(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: char);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    function Blankweg(Art: integer; var Btextstring: string): string;           // Blanks in Btextstring entfernen und in Result zurück geben
                                                                                // Art 1 = vor dem Text
                                                                                // Art 2 = hinter dem Text
                                                                                // Art 3 = vor und hinter dem Text
    function Uhr(von, bis: string): integer;                                     // prüfen ob die aktuelle Uhrzeit in von/bis enthalten ist und Rückgabe 0=nein 1=ja
    procedure SpeakText(const Textout: string);                                 // Textausgabe auf eingestelltem Audiogerät
    procedure EnterText(AText: String);                                         // Textausgabe in Tastaturpuffer
    procedure WasSollGemachtWerden(w1, w2, w3, w4, w5: String);                 // prüfen was mit der Eingabe gemacht werden soll (ausgabe laden)
    procedure StartMikro;                                                       // startet das Mikro für die Spracheingabe
  public
  end;

var
  Form1: TForm1;
  lanold: integer;                                                              // alte Länge des Eingabefeldes TEdit1
  anzein: integer;                                                              // Anzahl Durchläufe von Timer1Time
  taste: char;                                                                  // Tastaturcode des zuletzt eingegebenem Zeichen
  Inputs: Array[0..3] of Windows.TInput;                                        // Array für Ausgabe in den Tastaturpuffer
  auswert: string;                                                              // Text der Einagbe von TEdit1 zum Auswerten
  sta: integer;                                                                 // Status für Initialisierung der Variablen bei Programmstart. 1=vor Init, 2=nach Init
  vers: string;                                                                 // Versionsnummer des Programms
  anzrec: Integer;                                                              // Anzahl Sätze gelesen aus Datenbank
  sperr: integer;                                                               // Sperre für Buttons 0=gesperrt, 1=frei
  BUser: string;                                                                // Username der angemeldet ist
  JaNein: word;                                                                 // Ergebnis Ja/Nein Abfrage
  Tag: integer;                                                                 // Datum Tag
  Monat: integer;                                                               // Datum Monat
  Jahr: integer;                                                                // Datum Jahr
  neustart: integer;                                                            // Wenn ungleich 0 dann kein Neustart der Spracheinagbe bei Textausgabe (SpeakText)
  ausgabe: string;                                                              // Textausgabe für Procedure SpeakText
  verarbeitet: integer;                                                         // Anzahl Spracheinagben verarbeitet in
  uname: string;                                                                // HAL-Username (Benutzer dieses Programms)
  durchsichtig: integer;                                                        // Transparenzfaktor Form1 (0-255)
  Style: LongInt;                                                               // Hilfsvariable um Form1 sichtbar/transparent zu machen
  sagenaus: integer;                                                            // 'sagen Sie etwas' 0=eingeschaltet, 1=ausgeschaltet

implementation

{$R *.lfm}

{ TForm1 }

{
  Procedure Timer1Timer
      prüft alle 500 ms den Text aus der Eingabe TEdit1
      'programm beenden' = beendet das Programm
      'Carrige returm (#13)' = Eingabe verarbeiten und Edit1 neu starten
                               Eingabe wird im Timer2 verarbeitet.
      Wenn nach Eingabe Text 5 Sekunden lang nichts mehr eingegeben wird, wird die Einagbe neu gestartet
      Wenn 15 Sekunden lang nichts eingegeben wird, wird die Einagbe neu gestartet
  Eingabefelder
      keine
  Ausgabefelder
      keine
}
procedure TForm1.Timer1Timer(Sender: TObject);
  var
    l: integer;
    tt: string;
begin
  if taste = #13 then
  begin
    taste:=#0;
    tt:=Edit1.Text;
    tt:=Blankweg(3, tt);
    tt:=Lowercase(tt);
    Edit1.Text:=tt;
    if Edit1.Text = 'programm beenden' then
    begin
      Timer1.Enabled:=False;
      EnterText(Char(27));
      Application.HandleMessage;
      Edit1.ReadOnly:=True;
      Edit1.Color:=clInfoBk;
      Edit1.Font.Color:=clGray;
      Edit1.AutoSelect:=False;
      close;
    end else begin
      l:=Length(Edit1.Text);
      if l > 0 then
      begin
        auswert:=Edit1.Text;
        Timer2.Enabled:=True;
      end;
      Edit1.Text:='';
      lanold:=0;
      anzein:=0;
      EnterText(Char(27));
      Application.HandleMessage;
      sleep(1000);
      StartMikro;
    end;
  end else begin
    l:=Length(Edit1.Text);
    if l > 0 then
    begin
      if l = lanold then
      begin
        anzein:=anzein+1;
        if anzein = 7 then
        begin
          EnterText(Char(13));
        end;
      end else begin
        lanold:=l;
        anzein:=0;
      end;
    end else begin
      lanold:=0;
      anzein:=anzein+1;
      if sagenaus = 0 then
      begin
        if anzein = 20 then
        begin
          SpeakText('bitte sagen sie etwas');
        end;
        if anzein = 40 then
        begin
          SpeakText('bitte sagen sie etwas');
        end;
      end;
      if anzein = 60 then
      begin
        SpeakText('bitte sagen sie etwas');
      end;
      if sagenaus = 0 then
      begin
        if anzein = 80 then
        begin
          SpeakText('bitte sagen sie etwas');
        end;
        if anzein = 100 then
        begin
          SpeakText('bitte sagen sie etwas');
        end;
      end;
      if anzein = 120 then
      begin
        neustart:=1;
        SpeakText('eingabe abgebrochen, neustart');
        neustart:=0;
      end;
      if anzein = 121 then
      begin
        Edit1.Text:='';
        lanold:=0;
        anzein:=0;
        EnterText(Char(27));
        Application.HandleMessage;
        sleep(1000);
        StartMikro;
      end;
    end;
  end;
end;

{
  Procedure Timer2Timer
      prüft den Text aus der Variablen auswert
      liest mit dem Text die Datenbank hal
      und führt die Aktion aus
  Eingabefelder
      keine
  Ausgabefelder
      keine
}
procedure TForm1.Timer2Timer(Sender: TObject);
  var
    f1: string;
    f2: string;
    f3: string;
    f4: string;
    f5: string;
    f6: string;
    f7: string;
    anzgefunden: integer;
    a: integer;
    b: integer;
    c: integer;
    h: integer;
    l: integer;
    n: integer;
begin
  Timer2.Enabled:=False;
  anzgefunden:=0;
  verarbeitet:=0;
  f6:='';
  f7:=auswert;
  l:=Length(auswert);
  if l > 12 then
  begin
    f4:=Copy(auswert,1,13);
    if f4 = 'mein name ist' then
    begin
      f3:=auswert;
      auswert:='mein name ist';
      f7:=auswert;
      if l > 14 then
      begin
        uname:=Copy(f3,15,l-14);
        Label4.Caption:=uname;
      end;
    end;
  end else begin
    if l > 6 then
    begin
      f4:=Copy(auswert,1,7);
      if f4 = 'starte ' then
      begin
        f6:='start';
        f7:=auswert;
      end;
    end else begin
      if l > 8 then
      begin
        f4:=Copy(auswert,1,8);
        if f4 = 'fenster ' then
        begin
          f6:='fenster';
          f7:=auswert;
        end;
      end;
    end;
  end;
  ausgabe:='';
  n:=Length(ausgabe);
  if n > 0 then
  begin
    neustart:=0;
    SpeakText(ausgabe);
  end;
end;

{
  Function Blankweg
      entfernt Blanks am Amfang, am Ende
      oder am Anfang und Ende von Btextstring
      und gibt den String wieder zurück
  Eingabefelder
      Art (1=am Anfang, 2=am Ende, 3=am Anfang und am Ende)
      Btextstring = Text der bearbeitet werden soll
  Ausgabefelder
      Result = bearbeiteter Btextstring
}
function TForm1.Blankweg(Art: integer; var Btextstring: string): string;
  var
    laenge: integer;
    stelle: integer;
    vari12: integer;
    zeichen: string;
    ausgabe: string;
begin
  laenge:=Length(Btextstring);
  ausgabe:='';
  if laenge > 0 then
  begin
    ausgabe:=Btextstring;
    if ((Art = 1) or (Art = 3)) then
    begin
      vari12:=0;
      for stelle:=1 to laenge do
      begin
        zeichen:=Copy(Btextstring,stelle,1);
        if (vari12 = 0) then
        begin
          if (zeichen <> ' ') then
          begin
            vari12:=stelle;
          end;
        end;
      end;
      if vari12 > 0 then
      begin
        zeichen:=Btextstring;
        ausgabe:=Copy(zeichen,vari12,laenge-(vari12-1));
      end else begin
        ausgabe:='';
      end;
    end;
    laenge:=Length(ausgabe);
    if laenge > 0 then
    begin
      if ((Art = 2) or (Art = 3)) then
      begin
        vari12:=0;
        for stelle:=laenge downto 1 do
        begin
          zeichen:=Copy(ausgabe,stelle,1);
          if (vari12 = 0) then
          begin
            if (zeichen <> ' ') then
            begin
              vari12:=stelle;
            end;
          end;
        end;
        if (vari12 > 0) then
        begin
          zeichen:=ausgabe;
          ausgabe:=Copy(zeichen,1,vari12);
        end else begin
          ausgabe:='';
        end;
      end;
    end else begin
      ausgabe:='';
    end;
  end;
  Result:=ausgabe;
end;

{
  Procedure Edit1KeyPress
      läd den Tastencode in die Variable taste
  Eingabefelder
      Key = Tastencode des eingegebenen Zeichen
  Ausgabefelder
      keine
}
procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: char);
begin
  taste:=Key;
end;
{
  Procedure CheckBox1Change
      schaltet die Ansage 'sagen Sie etwas'
      ein (uncheckt) oder aus (checkt)
  Eingabefelder = keine
  Ausgabefelder = keine
}

procedure TForm1.CheckBox1Change(Sender: TObject);
begin
  if ((sagenaus = 0) and (CheckBox1.Checked)) then
  begin
    sagenaus:=1;
    CheckBox1.Caption:='''sagen Sie etwas'''+' einschalten';
    Panel1.Color:=clRed;
    Form1.ActiveControl:=Edit1;
    EnterText(Char(27));
    Application.HandleMessage;
    sleep(1000);
    StartMikro;
  end else begin
    if ((sagenaus = 1) and (not CheckBox1.Checked)) then
    begin
      sagenaus:=0;
      CheckBox1.Caption:='''sagen Sie etwas'''+' ausschalten';
      Panel1.Color:=clLime;
      Form1.ActiveControl:=Edit1;
      EnterText(Char(27));
      Application.HandleMessage;
      sleep(1000);
      StartMikro;
    end;
  end;
end;

{
  Procedure FormActivate
      initialisiert Variable,
      setzt Ein- und Ausgabefelder von Form1
      und startet die Verbindung zur Datenbank.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.FormActivate(Sender: TObject);
begin
  Label1.Caption:=widechar(169)+'LINSOFT         H A L 9 0 0 0           Datum: '+FormatDateTime('DD.MM.YYYY',now);
  Label2.Caption:='';
  Form1.Caption:='             H A L             Programmversion: '+vers+'          Username: '+BUser;
  if sta = 2 then
  begin
    sta:=1;
    neustart:=0;
    uname:='juergen';
    sagenaus:=0;
    CheckBox1.Caption:='''sagen Sie etwas'''+' ausschalten';
    Panel1.Color:=clLime;
    Label4.Caption:=uname;
    Timer1.Enabled:=False;
    Timer2.Enabled:=False;
    Edit1.ReadOnly:=True;
    Edit1.Color:=clInfoBk;
    Edit1.Font.Color:=clGray;
    Edit1.AutoSelect:=False;
    Image1.Picture.Bitmap.LoadFromFile(ExtractFilePath(ParamStr(0))+'hal.bmp');
    lanold:=0;
    anzein:=0;
    taste:=#0;
    Edit1.ReadOnly:=False;
    Edit1.Text:='';
    Edit1.Color:=clWhite;
    Edit1.Font.Color:=clBlue;
    Form1.ActiveControl:=Edit1;
    Edit1.AutoSelect:=True;
    StartMikro;
    Timer1.Enabled:=True;
  end;
end;

{
  Procedure FormClose
      Schließt das Programm
      und beendet die Verbindung zur Datenbank.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  EnterText(Char(27));
  Application.HandleMessage;
  sleep(1000);
  Form1.Cursor:=crDefault;
  Form1.Refresh;
  CloseAction:=caFree;
end;

{
Procedure FormCreate
      initialisiert Variable,
      setzt Username, Datum und Programmversion.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.FormCreate(Sender: TObject);
  var
    heute: string;
    h1: integer;
    h3: string;
    Rec: LongRec;
begin
  BUser:='                                                     ';
  try
    BUser:=SysUtils.GetEnvironmentVariable('USERNAME');
  except
    BUser:='unknown';
  end;
  heute:=FormatDateTime('DD.MM.YYYY',now);
  h1:=StrLen(PChar(heute));
  if (h1 = 10) then
  begin
    h3:=Copy(heute, 1, 2);
    Tag:=StrToInt(h3);
    h3:=Copy(heute, 4, 2);
    Monat:=StrToInt(h3);
    h3:=Copy(heute, 7, 4);
    Jahr:=StrToInt(h3);
  end;
  Rec:=LongRec(GetFileVersion(ParamStr(0)));
  vers:=Format('%.*d.%.*d', [2, Rec.Hi,2, Rec.Lo]);
  sta:=2;
  Style:=GetWindowLong(Handle, GWL_EXSTYLE);
  Style:=Style or WS_EX_LAYERED;
  SetWindowLong(Handle, GWL_EXSTYLE, Style);
  durchsichtig:=255;
  SetLayeredWindowAttributes(Handle, 0, durchsichtig, LWA_ALPHA);  // muss mindestens 1 Deckkraft (0-255) haben, damit es Events erhält!
end;

{
  Procedure SpeakText
      gibt den Text in der Variablen Textout auf eingestelltem Audiogerät aus
  Eingabefelder
      Textout = Text der gesprochen werden soll
  Ausgabefelder
      keine
}
procedure TForm1.SpeakText(const Textout: string);
var
  SpVoice: OleVariant;
  l: integer;
begin
  Edit1.Enabled:=False;
  l:=Length(Textout);
  if l > 0 then
  begin
// SpVoice.GetVoices.Items = Stimme in verschieden Sprachen (0-1)
// SpVoice.Volume = Lautstärke (0-100)
// SPVoice.Rate = Sprechgeschwindigkeit (-10 bis +10) Minus=Langsamer Plus=Schneller
    if sagenaus = 0 then
    begin
      SpVoice:=ComObj.CreateOleObject('SAPI.SpVoice');
      SpVoice.Voice:=SpVoice.GetVoices.Item(0);
      SpVoice.Speak(Textout, 0);
// 'Microsoft Hedda Desktop - German'
//      SpVoice.Speak(SpVoice.Voice.GetDescription, 0);
    end else begin
      if Textout <> 'bitte sagen sie etwas' then
      begin
        SpVoice:=ComObj.CreateOleObject('SAPI.SpVoice');
        SpVoice.Voice:=SpVoice.GetVoices.Item(0);
        SpVoice.Speak(Textout, 0);
      end;
    end;
  end;
  Edit1.Enabled:=True;
  Form1.ActiveControl:=Edit1;
  if neustart = 0 then
  begin
    EnterText(Char(27));
    Application.HandleMessage;
    sleep(1000);
    StartMikro;
  end;
end;

{
  Procedure EnterText
      stellt den Text in der Variablen AText in den Tastaturpuffer
  Eingabefelder
      AText = text der in den Keypuffer gestellt werden soll
  Ausgabefelder
      keine
}
procedure TForm1.EnterText(AText: String);
  var
    lCount: Integer;
    lScanCode: Smallint;
begin
  for lCount:=1 To Length(AText) Do
  begin
    lScanCode:=VkKeyScan(AText[lCount]);
    keybd_event(lScanCode, 0, 0, 0);
    keybd_event(lScanCode, 0, KEYEVENTF_KEYUP, 0);
  end;
end;

{
  Procedure WasSollGemachtWerden
      prüfen was mit der Spracheingabe gemacht werden soll und Variable ausgabe laden
  Eingabefelder
      w1 = Input der Spracheingabe
      w2 = Art der Spracheingabe
      w3 = von Wert
      w4 = bis Wert
      w5 = Output Sprachausgabe
  Ausgabefelder
      ausgabe = Text der gesprochen werden soll
}
procedure TForm1.WasSollGemachtWerden(w1, w2, w3, w4, w5: String);
  var
    l: integer;
    c: integer;
    w: string;
    x: string;
    h: string;
    m: string;
    t: TDateTime;
begin
  ausgabe:='';
  verarbeitet:=0;
  if w2 = 'ohne' then
  begin
    ausgabe:=w5;
    verarbeitet:=verarbeitet+1;
  end else begin
    if w2 = 'frage' then
    begin
      if w1 = 'was für ein datum ist heute' then
      begin
        w:=FormatDateTime('DD. mmmm YYYY',Now);
        ausgabe:='heute ist '+w;
        verarbeitet:=verarbeitet+1;
      end;
      if w1 = 'was für ein wochentag ist heute' then
      begin
        w:=FormatDateTime('dddd',Now);
        ausgabe:='heute ist '+w;
        verarbeitet:=verarbeitet+1;
      end;
      if w1 = 'wieviel uhr ist es' then
      begin
        t:=Now;
        w:=TimeToStr(t);
        h:=Copy(w,1,2);
        m:=Copy(w,4,2);
        x:=Copy(h,1,1);
        if x = '0' then h:=Copy(w,2,1);
        x:=Copy(m,1,1);
        if x = '0' then m:=Copy(w,5,1);
        ausgabe:='es ist '+h+' uhr und '+m+' minuten';
        verarbeitet:=verarbeitet+1;
      end;
    end else begin
      l:=Length(w2);
      if l > 2 then
      begin
        w:=Copy(w2,1,3);
        if w = 'uhr' then
        begin
          c:=Uhr(w3, w4);
          if c = 1 then
          begin
            ausgabe:=w5+' '+uname;
            verarbeitet:=verarbeitet+1;
          end;
        end;
      end;
    end;
  end;
end;

{
  Function Uhr
      prüfen ob die aktuelle Uhrzeit in von/bis enthalten ist
  Eingabefelder
      von = Uhrzeit von hh:mm
      bis = Uhrzeit bis hh:mm
  Ausgabefelder
      Result = ist in aktueller Zeit (0=nein, 1=ja)
}
function TForm1.Uhr(von, bis: string): integer;
var
  l: integer;
  c: integer;
  a: string;
  w: string;
  t: TTime;
  t1: TTime;
  t2: TTime;
  t3: TTime;
begin
  c:=0;
  t:=now;
  w:=TimeToStr(t);
  a:=Copy(w,1,5);
  t1:=StrToTime(a+':00');
  l:=Length(von);
  if l = 5 then
  begin
    t2:=StrToTime(von+':00');
    l:=Length(bis);
    if l = 5 then
    begin
      t3:=StrToTime(bis+':00');
      if ((t1 >= t2) and (t1 <= t3)) then
      begin
        c:=1;
      end;
    end;
  end;
  Result:=c;
end;

{
  Procedure WasSollGemachtWerden
      startet das Mikro für die Spracheingabe (Win+H)
  Eingabefelder
      keine
  Ausgabefelder
      keine
}
procedure TForm1.StartMikro;
begin
//  VK_LSHIFT     =  Shifttaste
//  VK_LCONTROL   =  STRG-Taste
//  VK_LMENU      =  ALT-Taste
//  VK_RMENU      =  ALT Gr-Taste
//  VK_LWIN       =  Windows-Taste (Win)
  Inputs[0]._Type:=INPUT_KEYBOARD;
  Inputs[0].ki.wVk:=VK_LWIN;
  Inputs[0].ki.dwFlags:=0;
  Inputs[1]._Type:=INPUT_KEYBOARD;
  Inputs[1].ki.wVk:=Ord('H');
  Inputs[1].ki.dwFlags:=0;
  Inputs[2]._Type:=INPUT_KEYBOARD;
  Inputs[2].ki.wVk:=Ord('H');
  Inputs[2].ki.dwFlags:=KEYEVENTF_KEYUP;
  Inputs[3]._Type:=INPUT_KEYBOARD;
  Inputs[3].ki.wVk:=VK_LWIN;
  Inputs[3].ki.dwFlags:=KEYEVENTF_KEYUP;
  Windows.SendInput(4, @Inputs[0], SizeOf(TInput));
end;

end.

